// RichEdit41View.cpp : implementation of the CRichEdit41View class
//

#include "stdafx.h"
#include "RichEdit41.h"

#include "RichEdit41Doc.h"
#include "CntrItem.h"
#include "RichEdit41View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRichEdit41View

IMPLEMENT_DYNCREATE(CRichEdit41View, CRichEditView)

BEGIN_MESSAGE_MAP(CRichEdit41View, CRichEditView)
	//{{AFX_MSG_MAP(CRichEdit41View)
	ON_WM_DESTROY()
	ON_COMMAND(ID_EDIT_REDO, OnEditRedo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_REDO, OnUpdateEditRedo)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CRichEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRichEdit41View construction/destruction

// Note: MSFTEDIT_CLASS is not defined in MFC6.0 and older
#ifndef MSFTEDIT_CLASS
#define MSFTEDIT_CLASS L"RICHEDIT50W";
#endif

CRichEdit41View::CRichEdit41View()
{
	m_strClass = MSFTEDIT_CLASS;
}

CRichEdit41View::~CRichEdit41View()
{
}

BOOL CRichEdit41View::PreCreateWindow(CREATESTRUCT& cs)
{
	return CRichEditView::PreCreateWindow(cs);
}

void CRichEdit41View::OnInitialUpdate()
{
	CRichEditView::OnInitialUpdate();


	SetMargins(CRect(720, 720, 720, 720));
}

/////////////////////////////////////////////////////////////////////////////
// CRichEdit41View printing

BOOL CRichEdit41View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}


void CRichEdit41View::OnDestroy()
{
	// CRichEditView::OnDestroy(); // <-- move this line below
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if(pActiveItem != NULL && pActiveItem->GetActiveView() == this)
	{
		pActiveItem->Deactivate();
		ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
	}
	CRichEditView::OnDestroy(); // <-- moved from above
}


/////////////////////////////////////////////////////////////////////////////
// CRichEdit41View diagnostics

#ifdef _DEBUG
void CRichEdit41View::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CRichEdit41View::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}

CRichEdit41Doc* CRichEdit41View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CRichEdit41Doc)));
	return (CRichEdit41Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRichEdit41View message handlers

void CRichEdit41View::OnEditRedo() 
{
   SendMessage(EM_REDO, 0, 0);
}

void CRichEdit41View::OnUpdateEditRedo(CCmdUI* pCmdUI) 
{
   BOOL bCanRedo = (BOOL)::SendMessage(m_hWnd, EM_CANREDO, 0, 0);
	pCmdUI->Enable(bCanRedo);
}
